<?php
namespace Geral\Logic\ParceiroNegocio;
use \Geral\Util\Novocodigo;
use \Geral\Util\Ambiente;
use \Geral\Entities\Endeclie;
use \Geral\Entities\Endeforn;
use \Academico\Entities\Endeprospect;
use \Pedidos\Entities\Endevende;
use \Geral\Entities\Enderecoparc as EnderecoparcEntity;
use Geral\Entities\Cliente;
use Geral\Entities\Fornecedor;
use Geral\Entities\Vendedor;
use Geral\Entities\Prospect;

class Enderecoparc {
	
	public static function novoCodigo(){
        return Novocodigo::geraCodigo(Ambiente::getNrorg(),'ENDERECOPARC', 1 , 10, true);
	}
	
	public static function deleta_filho_enderecoparc($nrenderecoparc, $nrorg){
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
        try{
            $sql = "DELETE FROM ENDECLIE WHERE NRENDERECOPARC = ".$nrenderecoparc." AND NRORG = ".$nrorg;
            \Setforms2\Runtime\Connection::getInstance()->execute($sql);
            
             $sql = "DELETE FROM ENDEFORN WHERE NRENDERECOPARC = ".$nrenderecoparc." AND NRORG = ".$nrorg;
            \Setforms2\Runtime\Connection::getInstance()->execute($sql);

             $sql = "DELETE FROM ENDEPROSPECT WHERE NRENDERECOPARC = ".$nrenderecoparc." AND NRORG = ".$nrorg;
            \Setforms2\Runtime\Connection::getInstance()->execute($sql);

             $sql = "DELETE FROM ENDEVENDE WHERE NRENDERECOPARC = ".$nrenderecoparc." AND NRORG = ".$nrorg;
            \Setforms2\Runtime\Connection::getInstance()->execute($sql);

            $connection->flush();
            $connection->commit();
        } catch(\Exception $e) {
            $connection->rollback();
            throw $e;
        }
	}

    public static function rotinaParceriaEndereco($tipoparceria, $nrparcnegocio, $nrenderecoparc, $nrorg){
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $enderecoparc = EnderecoparcEntity::findOneByNrenderecoparcAndNrorg($nrenderecoparc, $nrorg);
            $idtpendereco = null;
            if ($enderecoparc instanceof EnderecoparcEntity) {
                switch ($enderecoparc->getCdtipoendereco()) {
                    case 'PRINCIPAL':
                        $idtpendereco = 'P';
                        break;
                    case 'COBRANCA':
                        $idtpendereco = 'C';
                        break;
                    case 'COMERCIAL':
                        $idtpendereco = 'M';
                        break;
                    case 'ENTREGA':
                        $idtpendereco = 'T';
                        break;
                    case 'EXTERIOR':
                        $idtpendereco = 'E';
                        break;
                    case 'EXPORTACAO':
                        $idtpendereco = 'X';
                        break;
                    case 'OUTROS':
                        $idtpendereco = 'O';
                        break;
                }
            }
            $tipoparceria = explode(',', $tipoparceria);
            if (in_array('CLIENTE', $tipoparceria)) {
                $endeclie = Endeclie::findOneByNrenderecoparcAndNrorg($nrenderecoparc, $nrorg);
                if (empty($endeclie)) {
                    $cliente = Cliente::findOneByNrparcnegocioAndNrorg($nrparcnegocio, $nrorg);
                    if ($cliente instanceof Cliente) {
                        $endeclie = new Endeclie();
                        $endeclie->setNrorg($nrorg);
                        $endeclie->setNrenderecoparc($nrenderecoparc);
                        $endeclie->setCdcliente($cliente->getCdcliente());
                        $endeclie->setidtpendeclie($idtpendereco);
                        $endeclie->setCdpais($enderecoparc->getCdpais());
                        $endeclie->setSgestado($enderecoparc->getSgestado());
                        $endeclie->setCdmunicipio($enderecoparc->getCdmunicipio());
                        $endeclie->setDsendeclie($enderecoparc->getDsendereco() . ", " . $enderecoparc->getNrimovelendereco());
                        $endeclie->setCdbairro($enderecoparc->getCdbairro());
                        $endeclie->setDscompendcli($enderecoparc->getDscompleendereco());
                        $endeclie->setNmbairclie($enderecoparc->getNmbairroendereco());
                        $endeclie->setNrcepclie($enderecoparc->getNrcependereco());
                        $endeclie->setNrenderecoparc($enderecoparc->getNrenderecoparc());
                        $endeclie->setIdativo('S');
                        $endeclie->setDtinclusao(\Geral\Util\DateUtil::getDataAtual());
                        $endeclie->setCdoperinclusao(Ambiente::getCdOperador());
                        $endeclie->setNrorginclusao(Ambiente::getNrorg());
                        $endeclie->persist();
                    }
                }
                else{
                    $endeclie->setCdpais($enderecoparc->getCdpais());
                    $endeclie->setSgestado($enderecoparc->getSgestado());
                    $endeclie->setCdmunicipio($enderecoparc->getCdmunicipio());
                    $endeclie->setDsendeclie($enderecoparc->getDsendereco() . ", " . $enderecoparc->getNrimovelendereco());
                    $endeclie->setCdbairro($enderecoparc->getCdbairro());
                    $endeclie->setDscompendcli($enderecoparc->getDscompleendereco());
                    $endeclie->setNmbairclie($enderecoparc->getNmbairroendereco());
                    $endeclie->setNrcepclie($enderecoparc->getNrcependereco());
                    $endeclie->setDtultatu(\Geral\Util\DateUtil::getDataAtual());
                    $endeclie->setCdoperultatu(Ambiente::getCdOperador());
                    $endeclie->setNrorgultatu(Ambiente::getNrorg());
                    $endeclie->persist();
                }
            }

            if ($idtpendereco == 'P'||$idtpendereco == 'C'||$idtpendereco == 'E'||$idtpendereco == 'X') {

                if (in_array('FORNECEDOR', $tipoparceria)) {
                    $endeforn = Endeforn::findOneByNrenderecoparcAndNrorg($nrenderecoparc, $nrorg);
                    if (empty($endeforn)) {
                        $fornecedor = Fornecedor::findOneByNrparcnegocioAndNrorg($nrparcnegocio, $nrorg);
                        if ($fornecedor instanceof Fornecedor) {
                            $endeforn = new Endeforn();
                            $endeforn->setNrorg($nrorg);
                            $endeforn->setNrenderecoparc($nrenderecoparc);
                            $endeforn->setCdforneced($fornecedor->getCdforneced());
                            $endeforn->setIdtpendeforn($idtpendereco);
                            $endeforn->setCdpais($enderecoparc->getCdpais());
                            $endeforn->setSgestado($enderecoparc->getSgestado());
                            $endeforn->setCdmunicipio($enderecoparc->getCdmunicipio());
                            $endeforn->setDsendeforn($enderecoparc->getDsendereco());
                            $endeforn->setDscompendfor($enderecoparc->getDscompleendereco());
                            $endeforn->setNmbairforn($enderecoparc->getNmbairroendereco());
                            $endeforn->setNrcepforn($enderecoparc->getNrcependereco());
                            $endeforn->setNrenderecoparc($enderecoparc->getNrenderecoparc());
                            $endeforn->setNrendefornsep($enderecoparc->getNrimovelendereco());
                            $endeforn->setCdlogradouro($enderecoparc->getCdlogradouro());
                            $endeforn->setIdativo('S');
                            $endeforn->setDtinclusao(\Geral\Util\DateUtil::getDataAtual());
                            $endeforn->setCdoperinclusao(Ambiente::getCdOperador());
                            $endeforn->setNrorginclusao(Ambiente::getNrorg());
                            $endeforn->persist();
                        }
                    }
                    else{
                        $endeforn->setCdpais($enderecoparc->getCdpais());
                        $endeforn->setSgestado($enderecoparc->getSgestado());
                        $endeforn->setCdmunicipio($enderecoparc->getCdmunicipio());
                        $endeforn->setDsendeforn($enderecoparc->getDsendereco());
                        $endeforn->setDscompendfor($enderecoparc->getDscompleendereco());
                        $endeforn->setNmbairforn($enderecoparc->getNmbairroendereco());
                        $endeforn->setNrcepforn($enderecoparc->getNrcependereco());
                        $endeforn->setNrendefornsep($enderecoparc->getNrimovelendereco());
                        $endeforn->setCdlogradouro($enderecoparc->getCdlogradouro());
                        $endeforn->setDtultatu(\Geral\Util\DateUtil::getDataAtual());
                        $endeforn->setCdoperultatu(Ambiente::getCdOperador());
                        $endeforn->setNrorgultatu(Ambiente::getNrorg());
                        $endeforn->persist();
                    }
                }
            }


            if ($idtpendereco == "P") {
                if (in_array('VENDEDOR', $tipoparceria)) {
                    $endevende = Endevende::findOneByNrenderecoparcAndNrorg($nrenderecoparc, $nrorg);
                    if (empty($endevende)) {
                        $vendedor = Vendedor::findOneByNrparcnegocioAndNrorg($nrparcnegocio, $nrorg);
                        if ($vendedor instanceof Vendedor) {
                            $endevende = new Endevende();
                            $endevende->setNrorg($nrorg);
                            $endevende->setNrenderecoparc($nrenderecoparc);
                            $endevende->setCdvendedor($vendedor->getCdvendedor());
                            $endevende->setIdtpendeven($idtpendereco);
                            $endevende->setCdpais($enderecoparc->getCdpais());
                            $endevende->setSgestado($enderecoparc->getSgestado());
                            $endevende->setCdmunicipio($enderecoparc->getCdmunicipio());
                            $endevende->setCdbairro($enderecoparc->getCdbairro());
                            $endevende->setDsendeven($enderecoparc->getDsendereco() . ", " . $enderecoparc->getNrimovelendereco());
                            $endevende->setNmbairven($enderecoparc->getNmbairroendereco());
                            $endevende->setNrcepven($enderecoparc->getNrcependereco());
                            $endevende->setNrenderecoparc($enderecoparc->getNrenderecoparc());
                            $endevende->setIdativo('S');
                            $endevende->setDtinclusao(\Geral\Util\DateUtil::getDataAtual());
                            $endevende->setCdoperinclusao(Ambiente::getCdOperador());
                            $endevende->setNrorginclusao(Ambiente::getNrorg());
                            $endevende->persist();
                        }
                    }
                    else{
                        $endevende->setCdpais($enderecoparc->getCdpais());
                        $endevende->setSgestado($enderecoparc->getSgestado());
                        $endevende->setCdmunicipio($enderecoparc->getCdmunicipio());
                        $endevende->setCdbairro($enderecoparc->getCdbairro());
                        $endevende->setDsendeven($enderecoparc->getDsendereco() . ", " . $enderecoparc->getNrimovelendereco());
                        $endevende->setNmbairven($enderecoparc->getNmbairroendereco());
                        $endevende->setNrcepven($enderecoparc->getNrcependereco());
                        $endevende->setDtultatu(\Geral\Util\DateUtil::getDataAtual());
                        $endevende->setCdoperultatu(Ambiente::getCdOperador());
                        $endevende->setNrorgultatu(Ambiente::getNrorg());
                        $endevende->persist();
                    }
                }
            }

            if ($idtpendereco != "M") {
                if (in_array('PROSPECT', $tipoparceria)) {
                    $endeprospect = Endeprospect::findOneByNrenderecoparcAndNrorg($nrenderecoparc, $nrorg);
                    if (empty($endeprospect)) {
                        $prospect = Prospect::findOneByNrparcnegocioAndNrorg($nrparcnegocio, $nrorg);
                        if ($prospect instanceof Prospect) {
                            $endeprospect = new Endeprospect();
                            $endeprospect->setNrorg($nrorg);
                            $endeprospect->setNrenderecoparc($nrenderecoparc);
                            $endeprospect->setCdprospect($prospect->getCdprospect());
                            $endeprospect->setIdtpendepros($idtpendereco);
                            $endeprospect->setCdpais($enderecoparc->getCdpais());
                            $endeprospect->setSgestado($enderecoparc->getSgestado());
                            $endeprospect->setCdmunicipio($enderecoparc->getCdmunicipio());
                            $endeprospect->setCdbairro($enderecoparc->getCdbairro());
                            $endeprospect->setDsendepros($enderecoparc->getDsendereco());
                            $endeprospect->setNrimovelendereco($enderecoparc->getNrimovelendereco());
                            $endeprospect->setNmbairpros($enderecoparc->getNmbairroendereco());
                            $endeprospect->setNrceppros($enderecoparc->getNrcependereco());
                            $endeprospect->setNrenderecoparc($enderecoparc->getNrenderecoparc());
                            $endeprospect->setIdativo('S');
                            $endeprospect->setDtinclusao(\Geral\Util\DateUtil::getDataAtual());
                            $endeprospect->setCdoperinclusao(Ambiente::getCdOperador());
                            $endeprospect->setNrorginclusao(Ambiente::getNrorg());
                            $endeprospect ->persist();
                        }
                    }
                    else{
                        $endeprospect->setCdpais($enderecoparc->getCdpais());
                        $endeprospect->setSgestado($enderecoparc->getSgestado());
                        $endeprospect->setCdmunicipio($enderecoparc->getCdmunicipio());
                        $endeprospect->setCdbairro($enderecoparc->getCdbairro());
                        $endeprospect->setDsendepros($enderecoparc->getDsendereco());
                        $endeprospect->setNrimovelendereco($enderecoparc->getNrimovelendereco());
                        $endeprospect->setNmbairpros($enderecoparc->getNmbairroendereco());
                        $endeprospect->setNrceppros($enderecoparc->getNrcependereco());
                        $endeprospect->setDtultatu(\Geral\Util\DateUtil::getDataAtual());
                        $endeprospect->setCdoperultatu(Ambiente::getCdOperador());
                        $endeprospect->setNrorgultatu(Ambiente::getNrorg());
                        $endeprospect ->persist();
                    }
                }
            }

            $connection->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }

	public static function validaSave($nrparcnegocio, $cdtipoendereco, $nrorg){
    try{
        $novo = \Geral\Entities\Enderecoparc::findOneByNrparcnegocioAndCdtipoenderecoAndNrorg($nrparcnegocio, $cdtipoendereco, $nrorg);
        if ($novo instanceof \Geral\Entities\Enderecoparc) {
      		throw new \Exception(tk_get_message_by_name('msg_tipoendereco_jcad'));
		}
        return (!($novo instanceof \Geral\Entities\Enderecoparc));
        }catch(\Exception $e){
           throw $e;
        }
	}
}
